						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

BmpView_CreateBitmap	PROC	hWnd:HWND,lpszFileName:LPSTR
						LOCAL	hDC:HDC

;	========================================
;	=== Charger l'image depuis le disque ===
;	========================================

						push	DWord Ptr [lpszFileName]	; Nom du fichier
						call	BitmapFromFile

;	=========================================
;	=== Le bitmap a-t-il pu tre charg ? ===
;	=========================================

						test	eax,eax
						jz		BmpView_CreateBitmap_Error	; Non

						mov		DWord Ptr [hImage],eax		; Handle du bitmap

;	============================================================
;	=== Obtenir les informations relatives  l'image charge ===
;	============================================================

						push	OFFSET Image				; Structure BITMAP
						push	SIZEOF BITMAP				; Taille de la structure BITMAP
						push	eax							; Handle de l'image
						call	GetObject 

;	=================================================
;	=== Initialiser la structure BITMAPINFOHEADER ===
;	=================================================

						mov		DWord Ptr [ImageInfo.bmiHeader.biSize],SIZEOF BITMAPINFOHEADER

						mov		eax,DWord Ptr [Image.bmWidth]
						mov		DWord Ptr [ImageInfo.bmiHeader.biWidth],eax

						mov		eax,DWord Ptr [Image.bmHeight]
						mov		DWord Ptr [ImageInfo.bmiHeader.biHeight],eax

						mov		Word Ptr [ImageInfo.bmiHeader.biPlanes],1

						mov		ax,Word Ptr Image.bmBitsPixel
						mov		Word Ptr [ImageInfo.bmiHeader.biBitCount],ax

						mov		DWord Ptr [ImageInfo.bmiHeader.biCompression],BI_RGB

;	=====================================================================
;	=== Calculer le rapport entre la largeur et la hauteur de l'image ===
;	=====================================================================

						mov		eax,DWord Ptr [Image.bmWidth]

						cmp		eax,DWord Ptr [Image.bmHeight]
						jg		BmpView_CreateBitmap_Horizontale

BmpView_CreateBitmap_Verticale :

						fild	DWord Ptr [Image.bmWidth]
						fidiv	DWord Ptr [Image.bmHeight]
						fst		QWord Ptr [dwImageRatio]

						jmp		BmpView_CreateBitmap_Continue

BmpView_CreateBitmap_Horizontale :

						fild	DWord Ptr [Image.bmHeight]
						fidiv	DWord Ptr [Image.bmWidth]
						fst		QWord Ptr [dwImageRatio]

BmpView_CreateBitmap_Continue :

;	========================
;	=== Cration d'un DC ===
;	========================

						push	DWord Ptr [hWnd]
						call	GetDC

						test	eax,eax
						jz		BmpView_CreateBitmap_Error

						mov		DWord Ptr [hDC],eax

;	==============================================================
;	=== Crer un bitmap tenant entirement dans la zone client ===
;	==============================================================

;						push	DWord Ptr [hDC]
;						push	DWord Ptr [hWnd]
;						call	Bitmap_Window

;	==================================================================
;	=== Allouer les blocs de mmoire pour les diffrentes tranches ===
;	=== Tranches : Rouge, Verte, Bleue, Jaune, Cyan, Magenta       ===
;	==================================================================

						push	DWord Ptr [hDC]
						call	CreateBitmap_Memory

						test	eax,eax
						jz		BmpView_CreateBitmap_End_2

;	===============================================
;	=== Obtenir les bits des diffrentes images ===
;	===============================================

						call	CreateBitmap_GetBits

						test	eax,eax
						jz		BmpView_CreateBitmap_End_1

;	==================================================
;	=== Crer les bitmaps des diffrentes tranches ===
;	==================================================

						push	DWord Ptr [hDC]
						push	DWord Ptr [hWnd]
						call	BmpView_CreateTranches

;	=====================
;	=== Librer le DC ===
;	=====================

						push	DWord Ptr [hDC]
						push	DWord Ptr [hWnd]
						call	ReleaseDC

						call	Bitmap_CountColors

;	===========================
;	=== Fin de la procdure ===
;	===========================

						xor		eax,eax								; Indiquer que tout est OK
						inc		eax
						jmp		BmpView_CreateBitmap_Exit

BmpView_CreateBitmap_End_2 :

;	==============================================================================
;	=== Librer la mmoire utilise car toutes les oprations n'ont pu aboutir ===
;	==============================================================================

						push	MB_OK or MB_APPLMODAL or MB_ICONERROR
						push	OFFSET szError
						push	OFFSET szFmtError_003
						push	DWord Ptr hWnd
						push	OFFSET BmpView_CreateBitmap_Error_Exit
						jmp		MessageBox

BmpView_CreateBitmap_End_1 :

						push	DWord Ptr [hDC]
						call	ReleaseDC

BmpView_CreateBitmap_Error :

						push	MB_OK or MB_APPLMODAL or MB_ICONERROR
						push	OFFSET szError
						push	OFFSET szFmtError_002
						push	DWord Ptr [hWnd]
						push	OFFSET BmpView_CreateBitmap_Error_Exit
						jmp		MessageBox

BmpView_CreateBitmap_Error_Exit :

						call	File_FreeMemory

						xor		eax,eax						; Indiquer que les oprations ont choues

BmpView_CreateBitmap_Exit :

						ret
BmpView_CreateBitmap	ENDP
