;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Alpha					PROC	USES EBX ECX EDX EDI ESI

; R = R * A / 256 - Thank You bitRAKE !
; G = G * A / 256 - bitrake@attbi.com
; B = B * A / 256 - http://home.attbi.com/~bitrake/

						cmp		Image.bmBitsPixel,32
						jne		Alpha_Abort

						mov		esi,DWord Ptr [lpImageBits]
						mov		ebx,DWord Ptr [Image.bmHeight]
						mov		edi,DWord Ptr [lpWork]

Alpha_yloop :

						mov		ecx,DWord Ptr [Image.bmWidth]

Alpha_xloop :

						mov		eax,DWord Ptr [esi] 
						mov		edx,eax

						rol		eax,16
						shr		edx,24		; A
						mul		dl			; B * A
						rol		eax,8
						mul		dl			; G * A
						rol		eax,8
						mul		dl			; R * A
						mov		al,dl
						ror		eax,8
						mov		DWord Ptr [edi],eax

						add		esi,SIZEOF DWord
						add		edi,SIZEOF DWord

						dec		ecx
						jnz		Alpha_xloop

						dec		ebx
						jnz		Alpha_yloop

						xor		eax,eax
						inc		eax
						jmp		Alpha_Exit

Alpha_Abort :

						xor		eax,eax

Alpha_Exit :

						ret
Alpha					ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

CompositeBlend proc USES ebx esi edi,  hSrcBm:DWORD,srcx:DWORD,srcy:DWORD,srcw:DWORD,srch:DWORD,hDstBm:DWORD,dstx:DWORD,dsty:DWORD 
    LOCAL bmsrc:BITMAP 
    LOCAL bmdst:BITMAP 

    invoke GetObject,hSrcBm,sizeof bmsrc,addr bmsrc 
    invoke GetObject,hDstBm,sizeof bmdst,addr bmdst 
     
    mov edx, bmdst.bmHeight 
    mov eax, bmdst.bmWidth 
    sub edx, srch 
    mov edi, bmdst.bmBits 
    sub edx, dsty 
    mul edx 
    add eax, dstx 
    lea edi, [edi + eax*4] 
     
    mov edx, bmsrc.bmHeight 
    mov eax, bmsrc.bmWidth 
    sub edx, srch 
    mov esi, bmsrc.bmBits 
    sub edx, srcy 
    mul edx 
    add eax, srcx 
    lea esi, [esi + eax*4] 

    shr srcw, 1 
    dec srcw 
    shl bmsrc.bmWidth, 2 
    shl bmdst.bmWidth, 2 

    Top    EQU <esi + ecx*8> 
    Bottom    EQU <edi + ecx*8> 
    Destination EQU <Bottom> 

    pxor        mm7, mm7 
    pcmpeqd        mm6, mm6 

; -- PreMultiplied Alpha -- 
; H = result color (y, yr, yg, yb) 
; F = top color (a, ar, ag, ab) 
; G = bottom color (b, br, bg, bb) 
; 
; Composite: H = (1-b)F + G 

BlendLoop: 
    mov ecx, srcw 

IFDEF __MMX_PLUS__ 

_0:    movq        mm1, [Bottom]        ; 8 bits per component 
    movq        mm0, [Top] 
    movq        mm2, mm1 
    punpcklbw    mm1, mm7 
    punpckhbw    mm2, mm7 
    pshufw        mm4, mm0, 11111111y 
    pshufw        mm5, mm0, 01010101y 
    pxor        mm4, mm6 
    pxor        mm5, mm6 
    pmulhuw        mm1, mm4 
    pmulhuw        mm2, mm5 
    packuswb    mm2, mm1 
    paddusb        mm2, mm0 
    movq        [Destination], mm2 
ELSE 

_0:    movq        mm1, [Bottom]        ; 8 bits per component 
    movq        mm0, [Top] 
    movq        mm2, mm1 

    punpcklbw    mm1, mm7 
    punpckhbw    mm2, mm7 

    movq        mm4, mm0 
    pxor        mm4, mm6 
    psrlw        mm4, 8 
    movq        mm5, mm4 

    punpcklwd    mm4, mm4 
    punpckhwd    mm5, mm5 
    punpckhdq    mm4, mm4 
    punpckhdq    mm5, mm5 

    pmullw        mm1, mm4 
    pmullw        mm2, mm5 

    psrlw        mm1, 8 
    psrlw        mm2, 8 

    packuswb    mm1, mm2 
    paddusb        mm1, mm0 

    movq        [Destination], mm1 
ENDIF 
    dec ecx 
    jns _0 

    add esi, bmsrc.bmWidth 
    add edi, bmdst.bmWidth 
    dec srch 
    jnz BlendLoop 

    ret 
CompositeBlend endp

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

BlendFixed proc uses edi esi ebx lpData:DWORD,\ 
             dwX:DWORD,dwY:DWORD,\ 
             dwWidth:DWORD, dwHeight:DWORD,\ 
             dwColor:DWORD, dwBmpWidth:DWORD 
     
    mov         eax, dwColor 
    movd        MM7, eax 
    pxor        MM6, MM6 
    punpcklbw   MM7, MM6            ; MM1: 0 C 0 C-0 C 0 C 
     
    mov     esi, lpData 
    mov     eax, dwBmpWidth 
    shl     eax, 2 
    mov     ecx, eax 
    mul     dwY 
    add     esi, eax 
    mov     eax, dwX 
    shl     eax, 2 
    add     esi, eax 
     
    mov     edi, dwHeight 
     
    xor     ebx, ebx 
    ALIGN 16 
    @nextline: 
         
        mov     edx, dwWidth 
        shr     edx, 2 
        xor     eax, eax 
        ALIGN 16 
        @nextpixel: 
            movq        MM0, [esi+eax*8]    ; MM0: X R G B-X R G B 
            movq        MM2, [esi+eax*8+8]  ; MM2: X R G B-X R G B 
            movq        MM1, MM0 
            movq        MM3, MM2 
            punpcklbw   MM0, MM6            ; MM0: 0 X 0 R-0 X 0 B 
            punpckhbw   MM1, MM6            ; MM1: 0 X 0 R-0 X 0 B 
            punpcklbw   MM2, MM6            ; MM2: 0 X 0 R-0 X 0 B 
            punpckhbw   MM3, MM6            ; MM3: 0 X 0 R-0 X 0 B 
                         
            paddw       MM0, MM7 
            paddw       MM1, MM7 
            paddw       MM2, MM7 
            paddw       MM3, MM7 
             
            psrlw       MM0, 1 
            psrlw       MM1, 1 
            psrlw       MM2, 1 
            psrlw       MM3, 1 
             
            packuswb    MM0, MM1 
            packuswb    MM2, MM3 
            movq        [esi+eax*8], MM0 
            movq        [esi+eax*8+8], MM2 
            add         eax, 2 
            dec         edx 
            jnz         @nextpixel   
         
        add     esi, ecx 
        inc     ebx 
        cmp     ebx, edi 
        jb      @nextline 
    emms 
ret 
BlendFixed endp

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

AlphaBlendNew	PROC dwSource:DWord,dwDestination:DWord,dwCount:DWord 
    mov eax,dwSource 
    mov edx,dwDestination 
    mov ecx,dwCount ; number of pixels/2 
    dec ecx 
    pxor mm7,mm7 
    movq mm0,[eax+ecx*8] 
    movq mm1,[edx+ecx*8] 
@@:    movq mm4,mm0 
    movq mm2,mm0 
    psrlw mm4,1 
    movq mm3,mm1 
    movq mm5,mm4 
    punpcklbw mm0,mm7 
    punpcklbw mm1,mm7 
    punpckhbw mm2,mm7 
    punpckhbw mm3,mm7 
    psubsw mm0,mm1 
    psubsw mm2,mm3 
    punpcklwd mm4,mm4 
    punpckhwd mm5,mm5 
    punpckhdq mm4,mm4 
    punpckhdq mm5,mm5 
    psllw mm0,1 
    psllw mm2,1 
    pmulhw mm0,mm4 
    pmulhw mm2,mm5 
    paddsw mm0,mm1 
    paddsw mm2,mm3 
    packuswb mm0,mm2 
    movq [edx+ecx*8],mm0 
    dec ecx 
    movq mm0,[eax+ecx*8] 
    movq mm1,[edx+ecx*8] 
    jns @B 
    ret
AlphaBlendNew	ENDP
;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
