;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Souvans_Work				PROC

						mov		ebx,DWord Ptr [lpImageBits]
						mov		edx,DWord Ptr [lpWork]
						mov		edi,DWord Ptr [Image.bmHeight]

Souvans_Work_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]

Souvans_Work_Loop_1 :

						mov		eax,DWord Ptr [ebx]
						push	edx
						mov		ecx,eax				; Green
						mov		edx,eax				; Blue
						and		edx,0ffh
						ror		ecx,8
						and		ecx,0ffh
						ror		eax,16
						and		eax,0ffh
						cmp		eax,ecx
						cmovle	eax,ecx
						cmp		eax,edx
						cmovle	eax,edx
						mov		ecx,eax
						rol		ecx,8
						or		eax,ecx
						rol		ecx,8
						or		eax,ecx
						pop		edx
						mov		DWord Ptr [edx],eax

Souvans_Work_Loop_2 :

						add		ebx,SIZEOF DWord
						add		edx,SIZEOF DWord

						dec		esi
						jnz		Souvans_Work_Loop_1

						dec		edi
						jnz		Souvans_Work_Loop

						ret
Souvans_Work				ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

SouvansWmCreate			PROC	hWnd:HWND
						LOCAL	hTmp:HBITMAP
						LOCAL	hDC:HDC

						push	DWord Ptr [hWnd]
						call	Window_SetDim

						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		GetDC

						mov		DWord Ptr [hDC],eax

						push	DIB_RGB_COLORS
						push	OFFSET ImageInfo
						push	DWord Ptr [lpWork]
						push	CBM_INIT
						push	OFFSET ImageInfo
						push	DWord Ptr hDC
						push	OFFSET $ + 10
						jmp		CreateDIBitmap

						mov		DWord Ptr [hTmp],eax

						push	DWord Ptr [hDC]
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		ReleaseDC

						push	DWord Ptr [hTmp]
						push	0
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		SetWindowLong

						xor		eax,eax
						ret
SouvansWmCreate			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

SouvansWmPaint			PROC	hWnd:HWND
						LOCAL	hDC:HDC
						LOCAL	hDCMem:HDC
						LOCAL	hBmpOld
						LOCAL	hBmpImage:HBITMAP
						LOCAL	dwNewWidth:DWord
						LOCAL	dwNewHeight:DWord
						LOCAL	rc:RECT
						LOCAL	rc2:RECT
						LOCAL	PsP:PAINTSTRUCT

						lea		eax,PsP

						push	eax
						push	DWord Ptr [hWnd]
						call	BeginPaint 

						mov		DWord Ptr [hDC],eax

						invoke	CreateCompatibleDC,hDC
						mov		DWord Ptr [hDCMem],eax

						push	0
						push	DWord Ptr [hWnd]
						call	GetWindowLong

						mov		DWord Ptr [hBmpImage],eax

						invoke	SelectObject,hDCMem,hBmpImage
						mov		DWord Ptr [hBmpOld],eax

						invoke	GetClientRect,hWnd,ADDR rc

						push	DWord Ptr [hWnd]
						call	Bitmap_Proportions

						mov		DWord Ptr [dwNewWidth],eax
						mov		DWord Ptr [dwNewHeight],edx

						invoke	SetRect,ADDR rc2,0,0,rc.right,rc.bottom

						push	LTGRAY_BRUSH
						call	GetStockObject

						push	eax
						lea		eax,rc2
						push	eax
						push	DWord Ptr [hDC]
						call	FillRect

						invoke	SetStretchBltMode,hDC,COLORONCOLOR

						push	SRCCOPY
						push	DWord Ptr [Image.bmHeight]
						push	DWord Ptr [Image.bmWidth]
						push	0
						push	0
						push	DWord Ptr [hDCMem]
						push	DWord Ptr [dwNewHeight]
						push	DWord Ptr [dwNewWidth]
						push	0
						push	0
						push	DWord Ptr [hDC]
						call	StretchBlt

						invoke	SelectObject,hDCMem,hBmpOld

						lea		eax,PsP

						push	eax
						push	DWord Ptr [hWnd]
						call	EndPaint

						ret
SouvansWmPaint			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

SouvansWmClose			PROC	hWnd:HWND

						push	0
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		GetWindowLong

						push	eax
						push	OFFSET $ + 10
						jmp		DeleteObject

						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		DestroyWindow

						ret
SouvansWmClose			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

SouvansProc				PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

						mov		eax,DWord Ptr [uMsg]

						cmp		eax,WM_CREATE
						jne		@F

							push	DWord Ptr [hWnd]
							push	OFFSET SouvansProc_Exit
							jmp		SouvansWmCreate

@@ :

						cmp 	eax,WM_PAINT
						jne		@F

							push	DWord Ptr [hWnd]
							push	OFFSET SouvansProc_Exit
							jmp		SouvansWmPaint

@@ :

						cmp		eax,WM_ERASEBKGND
						jne		@F

							xor		eax,eax
							inc		eax
							jmp		SouvansProc_End

@@ :

						cmp		eax,WM_CLOSE
						jne		@F


							push	DWord Ptr [hWnd]
							push	OFFSET SouvansProc_End
							jmp		SouvansWmClose

@@ :

SouvansProc_Default :

						push	DWord Ptr [lParam]
						push	DWord Ptr [wParam]
						push	DWord Ptr [uMsg]
						push	DWord Ptr [hWnd]
						push	OFFSET SouvansProc_End
						jmp		DefWindowProc

SouvansProc_Exit :

						xor    eax,eax

SouvansProc_End :

						ret
SouvansProc				ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

;	============================================
;	=== Inverser l'image par l'oprateur NOT ===
;	============================================

Souvans					PROC	hWnd:HWND
						LOCAL	hTmp:HWND
						LOCAL	dwWidth:DWord
						LOCAL	dwHeight:DWord

						call	Souvans_Work

						mov		eax,DWord Ptr rcWorkArea.right
						sub		eax,DWord Ptr rcWorkArea.left
						mov		DWord Ptr dwWidth,eax

						mov		eax,DWord Ptr rcWorkArea.bottom
						sub		eax,DWord Ptr rcWorkArea.top
						mov		DWord Ptr dwHeight,eax

						push	NULL
						push	DWord Ptr [hInstance]
						push	NULL
						push	DWord Ptr [hWnd]
						push	DWord Ptr dwHeight
						push	DWord Ptr dwWidth
						push	rcWorkArea.top
						push	rcWorkArea.left
						push	WS_POPUP or WS_CAPTION or WS_VISIBLE or WS_SYSMENU
						push	OFFSET szSouvansTitle
						push	OFFSET szSouvansClass
						push	0
						call	CreateWindowEx

						mov		DWord Ptr [hTmp],eax

						push	SW_SHOW
						push	DWord Ptr [hTmp]
						call	ShowWindow

						push	DWord Ptr [hTmp]
						call	UpdateWindow

Souvans_Exit :

						ret
Souvans					ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
